; GUI #
include win64a.inc
ID_TXT		equ 100
ID_SEND_TXT	equ 101
ID_SEND_ICO	equ 102
ID_SEND_WAV	equ 103
IDC_IMG1 	equ 104
IDC_IMG2 	equ 105
IDC_DIALOG	equ 200
IDC_ICON1	equ 500
IDC_ICON2	equ 501

MUTEX_DATA_COUNT = 16
size_of_buffer	 = 96
MUTEX_ALL_ACCESS equ 1F0001h
cxDesired	= 32
cyDesired	= cxDesired
.code
WinMain proc 
	enter	30h,0
	mov	r9d,256;cx
	mov	[rbp-10h],r9
	mov	qword ptr [rbp-8],LR_DEFAULTCOLOR
	invoke	LoadImageA,IMAGE_BASE,IDC_ICON1,IMAGE_ICON;,256,256,LR_DEFAULTCOLOR
	mov	r9d,offset DialogProc
	mov	qword ptr[rbp-10h],rax;30h-10h=+20h
	invoke	DialogBoxParamA,IMAGE_BASE,IDC_DIALOG,HWND_DESKTOP
	invoke	RtlExitUserProcess,NULL
WinMain endp

DialogProc proc hWnddlg:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	MutexName[256]:word
local	SizeString:dword
local	hFile:qword
local	szReadWrite:qword	;number of bytes actually read or write
local	hResource:qword

	mov	hWnddlg,rcx
	mov	lParam,r9

	cmp	edx,WM_INITDIALOG
	je	wmINITDIALOG
	cmp	edx,WM_CLOSE
	je	wmCLOSE
	cmp	edx,WM_COMMAND
	je	wmCOMMAND
	cmp	edx,WM_DESTROY
	je	wmDESTROY
	xor	eax,eax
	jmp	exit0
wmINITDIALOG:mov hWnd,rcx
	invoke	GetDlgItem,,IDC_IMG1
	invoke	SendMessageA,eax,STM_SETIMAGE,IMAGE_ICON,lParam

	invoke	FindResource,0,2,RT_ICON; find the resource
	mov	hResource,rax
        invoke  SizeofResource,0,eax		; get its size
	mov	FSize,rax
	invoke	LoadResource,0,hResource	; load the resource
	invoke	LockResource,eax
	mov	pResource,rax 

        and	qword ptr[rsp+30h],LR_DEFAULTCOLOR
        mov	qword ptr[rsp+20h],cxDesired
	mov	qword ptr[rsp+28h],cyDesired
        invoke  CreateIconFromResourceEx,eax,FSize,TRUE,30000h
	invoke  SendDlgItemMessageA,hWnddlg,IDC_IMG2,STM_SETIMAGE,IMAGE_ICON,eax
;Create Sync Objects
	xor	edi,edi
@@:	lea	ecx,MutexName
	mov	edx,offset fmtH1
	invoke	wsprintfA,,,edi
	lea	r8d,MutexName
	invoke	CreateMutex,0,TRUE
	mov	mutexesH1[rdi*8],rax
	lea	ecx,MutexName
	mov	edx,offset fmtL1
	invoke	wsprintfA,,,edi
	lea	r8d,MutexName
	invoke	CreateMutex,0,TRUE
	mov	mutexesL1[rdi*8],rax
	lea	ecx,MutexName
	mov	edx,offset fmtH2
	invoke	wsprintfA,,,edi
	lea	r8d,MutexName
	invoke	CreateMutex,0,TRUE
	mov	mutexesH2[rdi*8],rax
	lea	ecx,MutexName
	mov	edx,offset fmtL2
	invoke	wsprintfA,,,edi
	lea	r8d,MutexName
	invoke	CreateMutex,0,TRUE
	mov	mutexesL2[rdi*8],rax
	inc	edi
	cmp	edi,MUTEX_DATA_COUNT
	jb	@b

	mov	r9d,offset Format5
	invoke	CreateEvent,0,TRUE,FALSE
	mov	hEventAck,rax

	mov	r9d,offset EVENT_RECEIVER_READY
	invoke	CreateEvent,NULL,TRUE,FALSE
	mov	eventReceiverReady,rax
	jmp	wmBYE
wmSEND_TXT:lea	r8d,MutexName
	invoke	GetDlgItemTextA,hWnd,ID_TXT,,256
	inc	eax
	mov	SizeString,eax
;-----------------------------------------------
	mov	edx,offset szWin
	invoke  FindWindowA,NULL
	invoke	PostMessageA,eax,WM_USER+1,hWnddlg,SizeString
;Send Data--------------------------------------
	invoke	WaitForSingleObject,eventReceiverReady,500        
        lea	esi,MutexName
	mov	eax,esi
	add	eax,SizeString
	mov	SizeString,eax
@@:	movzx	edi,byte ptr[rsi]
	and	edi,0Fh
	invoke	ReleaseMutex,mutexesL1[rdi*8]
	invoke	Sleep,1
	invoke	WaitForSingleObject,mutexesL1[rdi*8],INFINITE
	movzx	edi,byte ptr[rsi]
	shr	edi,4	
	invoke	ReleaseMutex,mutexesH1[rdi*8]
	invoke	WaitForSingleObject,mutexesH1[rdi*8],INFINITE
;-----------------------------------------------
	movzx	edi,byte ptr[rsi+1]
	and	edi,0Fh
	invoke	ReleaseMutex,mutexesL2[rdi*8]
	invoke	Sleep,1
	invoke	WaitForSingleObject,mutexesL2[rdi*8],INFINITE
	movzx	edi,byte ptr[rsi+1]
	shr	edi,4	
	invoke	ReleaseMutex,mutexesH2[rdi*8]
	invoke	WaitForSingleObject,mutexesH2[rdi*8],INFINITE
;--------------------------------------------------------
        invoke	WaitForSingleObject,hEventAck,INFINITE
        add	esi,2
	cmp	esi,SizeString;dec	SizeString
	jb	@b
	jmp	wmBYE
wmSEND_ICO:mov	edx,offset szWin
	invoke  FindWindowA,NULL
	invoke	PostMessageA,eax,WM_USER+2,hWnddlg,FSize
;Send Data--------------------------------------
	invoke	WaitForSingleObject,eventReceiverReady,500        
	mov	rsi,pResource
	mov	eax,esi
	add	rax,FSize
	mov	SizeString,eax
@@:	movzx	edi,byte ptr[rsi]
	and	edi,0Fh
	invoke	ReleaseMutex,mutexesL1[rdi*8]
	invoke	Sleep,1
	invoke	WaitForSingleObject,mutexesL1[rdi*8],INFINITE
	movzx	edi,byte ptr[rsi]
	shr	edi,4	
	invoke	ReleaseMutex,mutexesH1[rdi*8]
	invoke	WaitForSingleObject,mutexesH1[rdi*8],INFINITE
;-----------------------------------------------
	movzx	edi,byte ptr[rsi+1]
	and	edi,0Fh
	invoke	ReleaseMutex,mutexesL2[rdi*8]
	invoke	Sleep,1
	invoke	WaitForSingleObject,mutexesL2[rdi*8],INFINITE
	movzx	ebx,byte ptr[rsi+1]
	shr	ebx,4	
	invoke	ReleaseMutex,mutexesH2[rbx*8]
	invoke	WaitForSingleObject,mutexesH2[rbx*8],INFINITE

	invoke	WaitForSingleObject,hEventAck,INFINITE
	add	esi,2
	cmp	esi,SizeString
	jb	@b
	jmp	wmBYE
wmSEND_WAV:
	jmp	wmBYE
wmDESTROY:;Close Sync Objects
	invoke	CloseHandle,eventReceiverReady
	xor	edi,edi
@@:	invoke	CloseHandle,mutexesH1[rdi*8]
	invoke	CloseHandle,mutexesL1[rdi*8]
	invoke	CloseHandle,mutexesH2[rdi*8]
	invoke	CloseHandle,mutexesL2[rdi*8]
	inc	edi
	cmp	edi,MUTEX_DATA_COUNT
	jb	@b
	invoke	CloseHandle,hEventAck
	jmp	wmBYE
; ---------------------------------------------------------------------------
wmCOMMAND:cmp	r8d,BN_CLICKED shl 16 + ID_SEND_TXT
        je      wmSEND_TXT
	cmp	r8d,BN_CLICKED shl 16 + ID_SEND_ICO
        je      wmSEND_ICO
	cmp     r8d,BN_CLICKED shl 16 + IDCANCEL
        jne     wmBYE
wmCLOSE:invoke	EndDialog,,0
wmBYE:	mov	eax,TRUE
exit0:	leave
	retn
DialogProc endp
;---------------------------------------
.data
szWin		db "Mutex Reciever",0
hWnd		dq ?
EVENT_RECEIVER_READY db "EvReceiverReady",0
Format5		db "Song_of_the_South_A",0
fmtH1		db "MtxDataH1:%u",0
fmtL1		db "MtxDataL1:%u",0
fmtH2		db "MtxDataH2:%u",0
fmtL2		db "MtxDataL2:%u",0
FSize		dq ?
wav_file	db '..\Images\03.wav',0
align 10h
mutexesH1	dq 16 dup(?)
mutexesL1	dq 16 dup(?)
mutexesH2	dq 16 dup(?)
mutexesL2	dq 16 dup(?)
eventReceiverReady dq ?
hEventAck	dq ?
pResource	dq ?
end